/****************************************
 *		Muhammad khabir Ud Dulon		*
 *		03-03795-1						*
 ****************************************/


class MyVector
{
	Object vectorArray[];
	int index; // sequential last serial no
	int indexNext; // there may be no data before this no
	int cap;	// total size;

	MyVector()
	{
		index = 0;
		cap = 10;
		vectorArray = new Object[cap];
	}
	MyVector(int cap)
	{
		index = 0;
		this.cap = cap;
		vectorArray = new Object[cap];
	}

	public boolean myAdd(Object obj)
	{
		if(index < cap)
		{
			vectorArray[index++] = obj;
			return true;
		}
		return false;
	}

	public void myAdd(int index, Object element)
				throws ArrayIndexOutOfBoundsException
	{
		if(index >= cap)
			throw new ArrayIndexOutOfBoundsException();
		if(this.index > index)
			for(int i = this.index - 1; i >= index; i--)
				vectorArray[i+1] = vectorArray[i];
		vectorArray[index] = element;
		this.index++;
	}

	public void myAddElement(Object obj)
	{
		if(index < cap)
			vectorArray[index++] = obj;
		else
		{
			Object temp[] = new Object[cap];
			for(int i = 0; i<temp.length; i++)
				temp[i] = vectorArray[i];

			vectorArray = new Object[++cap];

			for(int i = 0; i<temp.length; i++)
				vectorArray[i] = temp[i];

			vectorArray[cap-1] = obj;
		}
	}

	public int myCapacity()
	{
		return cap;
	}

	public void myClear()
	{
		cap = 10;
		vectorArray = new Object[cap];
	}

	public boolean myContains(Object elem)
	{
		for(int i = 0; i<cap; i++)
			if(vectorArray[i] == elem)
				return true;
		return false;
	}

	public Object myElementAt(int index)
		throws ArrayIndexOutOfBoundsException
	{
		if(index >= cap)
			throw new ArrayIndexOutOfBoundsException();
		return vectorArray[index];
	}

	public boolean myEquals(Object o)
	{
		for(int i = 0; i<vectorArray.length; i++)
			if(this.vectorArray[i] == o)
				return true;
		return false;
	}

	public Object myGet(int index)
				throws ArrayIndexOutOfBoundsException
	{
		if(index >= cap)
			throw new ArrayIndexOutOfBoundsException();
		return vectorArray[index];
	}

	public int myIndexOf(Object elem)
	{
		for(int i = 0; i<cap; i++)
			if(vectorArray[i] == elem)
				return i;
		return -1;
	}

	public int myIndexOf(Object elem, int index)
	throws IndexOutOfBoundsException
	{
		if(index >= vectorArray.length)
			throw new IndexOutOfBoundsException();

		for(int i = index; i<vectorArray.length; i++)
			if(vectorArray[i] == elem)
				return i;
		return -1;
	}

	public void myInsertElementAt(Object obj, int index)
				throws ArrayIndexOutOfBoundsException
	{
		if(index >= cap)
			throw new ArrayIndexOutOfBoundsException();
		if(index <= this.index )
		{
			int i;
			Object ob[] = new Object[vectorArray.length + 2];

			for(i = 0; i<vectorArray.length; i++)
				ob[i] = vectorArray[i];

			vectorArray = new Object[ob.length];

			for(i = 0; i<index; i++)
				vectorArray[i] = ob[i];

			vectorArray[i++] = obj;

			for(  ; i<ob.length; i++)
				vectorArray[i] = ob[i];
		}

		if(index > this.index)
		{
			indexNext = index;
			vectorArray[index] = obj;
		}
	}

	public int myLastIndexOf(Object elem)
	{
		for(int i = this.myCapacity()-1; i>=0; i--)
			if(vectorArray[i] == elem)
				return i;
		return -1;
	}

	public int myLastIndexOf(Object elem, int index)
	throws IndexOutOfBoundsException
	{
		if(index > vectorArray.length)
			throw new IndexOutOfBoundsException();
		for(int i = index; i>=0; i--)
			if(vectorArray[i] == elem)
				return i;
		return -1;
	}

	public boolean myRemove(Object obj)
	{
		int i = 0;
		boolean found = false;
		for(  ; i<this.myCapacity(); i++)
			if(vectorArray[i] == obj)
				found = true;
		for(  ; i<this.myCapacity(); i++)
			vectorArray[i] = vectorArray[i+1];
		vectorArray[i] = null;

		return found;
	}

	public Object myRemove(int index)
				throws ArrayIndexOutOfBoundsException
	{
		int i;
		if(index >= cap)
			throw new ArrayIndexOutOfBoundsException();
		Object obj = new Object();
		obj = vectorArray[index];

		for( i = index; i<this.myCapacity(); i++)
			vectorArray[i] = vectorArray[i+1];
		vectorArray[i] = null;

		return obj;
	}

	public int mySize()
	{
		return index;
	}

	public void myTrimToSize()
	{
		Object obj[] = new Object[index];
		for(int i = 0; i < index; i++)
			obj[i] = vectorArray[i];

		vectorArray = new Object[index];

		for(int i = 0; i < index; i++)
			vectorArray[i] = obj[i];
	}
}

class VectorTest
{
	public static void main(String args[])
	{
		MyVector myV = new MyVector(15);

		Object obj  = new Object();
		Object obj1 = new Object();
		Object obj2 = new Object();
		Object obj3 = new Object();
		Object obj4 = new Object();

		String s = new String();
		myV.myAdd(s);
		myV.myAdd(obj1);
		myV.myAdd(2,obj2);
		myV.myAdd(3,obj3);
		myV.myAdd(4,obj4);
		myV.myAddElement(obj);

		System.out.println(myV.myCapacity());
		System.out.println(myV.myContains(obj2));
		System.out.println(myV.myElementAt(3));
		System.out.println(myV.myEquals(obj4));
		System.out.println(myV.myGet(1));
		System.out.println(myV.myIndexOf(obj3));
		System.out.println(myV.myIndexOf(obj4,2));

		myV.myInsertElementAt(obj2,2);

		System.out.println(myV.myLastIndexOf(obj4));
		System.out.println(myV.myLastIndexOf(obj3, 3));
		System.out.println(myV.myRemove(obj1));
		System.out.println(myV.myRemove(1));
		System.out.println(myV.mySize());

		myV.myClear();
		myV.myTrimToSize();
	}
}
