      import java.awt.*;
      import java.awt.event.*;
      import javax.swing.*;

public class Demo extends JFrame
{
        public class PanelDemo extends JFrame
    {
         private JPanel buttonPanel;
         private JButton buttons[];

       // set up GUI
       public PanelDemo()
       {
          super( "Panel Demo" );

          // get content pane
          Container container = getContentPane();

          // create buttons array
          buttons = new JButton[ 2 ];

          // set up panel and set its layout
          buttonPanel = new JPanel();
          buttonPanel.setLayout( new GridLayout( 1, buttons.length ) );


          for ( int count = 0; count < buttons.length; count++ )
          {
             buttons[ count ] = new JButton( "Button " + ( count + 1 ) );

           buttonPanel.add( buttons[ count ] );
             container.add( buttonPanel, BorderLayout.EAST );
          }



          container.add( buttonPanel, BorderLayout.NORTH );
          //container.add( buttonPanel[ 2 ], BorderLayout.NORTH );
          //container.add( buttonPanel[ 3 ], BorderLayout.EAST );
          //container.add( buttonPanel[ 4 ], BorderLayout.WEST );
          //container.add( buttonPanel[ 5 ], BorderLayout.CENTER );


          setSize( 450, 150 );
          setVisible( true );

       } // end constructor PanelDemo

public class TextFieldTest extends JFrame {
         private JTextField textField1, textField2, textField3;
         private JPasswordField passwordField;

       // set up GUI
       public TextFieldTest()
       {
          super( "Testing JTextField and JPasswordField" );

          Container container = getContentPane();
          container.setLayout( new FlowLayout() );

          // construct textfield with default sizing
          textField1 = new JTextField( 10 );
          container.add( textField1 );

          // construct textfield with default text
          textField2 = new JTextField( "Enter text here" );
          container.add( textField2 );

            textField3 = new JTextField( "Uneditable text field", 20 );
          textField3.setEditable( false );
          container.add( textField3 );

          // construct passwordfield with default text
          passwordField = new JPasswordField( "Hidden text" );
          container.add( passwordField );

          // register event handlers
          TextFieldHandler handler = new TextFieldHandler();
          textField1.addActionListener( handler );
          textField2.addActionListener( handler );
          textField3.addActionListener( handler );
          passwordField.addActionListener( handler );

          setSize( 325, 100 );
          setVisible( true );

       } // end constructor TextFieldTest


public class FlowLayoutDemo extends JFrame {
         private JButton leftButton, centerButton, rightButton;
         private Container container;
       private FlowLayout layout;

       // set up GUI and register button listeners
       public FlowLayoutDemo()
       {
          super( "FlowLayout Demo" );

          layout = new FlowLayout();

          // get content pane and set its layout
          container = getContentPane();
          container.setLayout( layout );

          // set up leftButton and register listener
          leftButton = new JButton( "Left" );
          container.add( leftButton );
              leftButton.addActionListener(

             new ActionListener() {  // anonymous inner class

                // process leftButton event
                public void actionPerformed( ActionEvent event )
                {
                   layout.setAlignment( FlowLayout.LEFT );

                   // realign attached components
                   layout.layoutContainer( container );
                }

             } // end anonymous inner class

          ); // end call to addActionListener

          // set up centerButton and register listener
          centerButton = new JButton( "Center" );
          container.add( centerButton );
          centerButton.addActionListener(

             new ActionListener() {  // anonymous inner class

                // process centerButton event
                public void actionPerformed( ActionEvent event )
                {
                   layout.setAlignment( FlowLayout.CENTER );

                   layout.layoutContainer( container );
                }
            }
          );

          // set up rightButton and register listener
          rightButton = new JButton( "Right" );
          container.add( rightButton );
          rightButton.addActionListener(

             new ActionListener() {  // anonymous inner class

                // process rightButton event
                public void actionPerformed( ActionEvent event )
                {
                   layout.setAlignment( FlowLayout.RIGHT );

                   // realign attached components
                   layout.layoutContainer( container );
                }
             }
          );

          setSize( 300, 75 );
          setVisible( true );
}


public class CheckBoxTest extends JFrame
      {
        private JTextField field;
        private JCheckBox bold, italic;

       // set up GUI
       public CheckBoxTest()
       {
          super( "JCheckBox Test" );

          // get content pane and set its layout
          Container container = getContentPane();
          container.setLayout( new FlowLayout() );

          // set up JTextField and set its font
          field = new JTextField( "Watch the font style change", 20 );
          field.setFont( new Font( "Serif", Font.PLAIN, 14 ) );
          container.add( field );

            bold = new JCheckBox( "Bold" );
          container.add( bold );

          italic = new JCheckBox( "Italic" );
          container.add( italic );

          // register listeners for JCheckBoxes
          CheckBoxHandler handler = new CheckBoxHandler();
          bold.addItemListener( handler );
          italic.addItemListener( handler );

          setSize( 275, 100 );
          setVisible( true );

       } // end CheckBoxText constructor


   }

       public static void main( String args[] )
       {
          Demo application = new Demo();
          PanelDemo application = new PanelDemo();
          CheckBoxTest application = new CheckBoxTest();
          TextFieldTest application = new TextFieldTest();
          FlowLayoutDemo application = new FlowLayoutDemo();
          application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
       }

